﻿angular.module('VPAdminHTML5Controllers').controller('SelectDisplays', function ($scope, $location, BannerControlService, Services, DisplaysTree) {
	$scope.lpAppTaskWebReady = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppTaskWebReady");
	$scope.lpAppSelect = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppSelect");
	$scope.lpAppSelectDisplay = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppSelectDisplay");
	$scope.lpAppPublish = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppPublish");
	$scope.lpAppLearnSelectDisplay = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppLearnSelectDisplay");
	$scope.gridColSelect = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("gridColSelect");
	$scope.gridColInitial = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("gridColInitial");
	$scope.mobileEnable = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("mobileEnable");
	$scope.gridColName = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("gridColName");
	$scope.cbForceRepublish = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("cbForceRepublish");
	$scope.lpWhatIsThis = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpWhatIsThis");
	$scope.rpAppGridSelectDisplay = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppGridSelectDisplay");
	$scope.rpAppButtonSelectApp = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppButtonSelectApp");
	$scope.rpAppButtonPublish = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("rpAppButtonPublish");

	//Pages: SelectDisplays 

    $scope.selectedAppName = BannerControlService;
    $scope.selectedAppType = BannerControlService;
    $scope.factoryTalkDirectory = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDServerName;
    var vpAdminApp = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp();

    $scope.Init = function () {

        vpAdminApp.publishLastPageIndex = 1;
        vpAdminApp.republish = true;
        var helpUrl = ViewPoint.Client.VPAdmin.VPAdminUtil.CreateHelpLink(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpAppLearnSelectDisplay_url"));
        document.getElementById('lpAppLearnSelectDisplay_url').href = helpUrl;
        var whatIsThisUrl = ViewPoint.Client.VPAdmin.VPAdminUtil.CreateHelpLink(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("lpWhatIsThis_url"));
        document.getElementById('lpWhatIsThis').href = whatIsThisUrl;
        document.getElementById('publishdisplays').className = 'active';//active to see the row in the menu 
        if (ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified) {
            $('body').css("cursor", "wait");            
            ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified = false;
            var selectDisplays = ViewPoint.Client.VPAdmin.SelectDisplays.GetSelectDisplayClass();
            var clientIdentifier = vpAdminApp.GetConnectionHelper().m_ClientIdentifier;

            var appToOpen = ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp()._CurrentFTDApplication;
            vpAdminApp.GridName = appToOpen;
            var reloadExistingApp = true;
            Services.GetDisplays(function (data, args) {                
                selectDisplays.GetDisplaysServiceCompleted(data, args);
                $scope.tree = args.getftViewApplication();      
                    
                if($scope.tree.length){     //reset the position of the scrollbar when the application is diferent           
                    if(localStorage['currentApp'] != $scope.tree[0].Name)
                    {
                        localStorage['scrollposition'] = '0';
                        localStorage['currentApp'] = $scope.tree[0].Name;
                    }
                }

                if (args.getResult() === 0){ 
                    document.getElementById('firstApp').style.display = 'block';
                    vpAdminApp.success = true;
                } else{
                    vpAdminApp.success = false;
                    document.getElementById('firstApp').style.display = 'none';
                }
                $scope.macros = args.getMacroList();
                $scope.forceRepublish = args.getForceRepublish();
                $scope.xmlDOM = args.getftViewApplicationDOM();
                DisplaysTree.tree = $scope.tree;
                DisplaysTree.DOM = $scope.xmlDOM;
                DisplaysTree.forceRepublish = $scope.forceRepublish;
                DisplaysTree.macroList = $scope.macros;
                //ppei: fix anomaly CVBFTVIEW-2321
                totalSelectedItems = $($scope.xmlDOM.find("GraphicsDisplay").find("Selected:Contains(true)")).length
                totalMobileEnableItems = $($scope.xmlDOM.find("GraphicsDisplay").find("MobileEnable:Contains(true)")).length;
                //if (!vpAdminApp.defaultStartupMacro) {
                    vpAdminApp.defaultStartupMacro = ($scope.xmlDOM.find("StartupMacro")[0])? ($scope.xmlDOM.find("StartupMacro")[0]).textContent : 'None';
                    var matchedMacro = false;
                    for(var i =0; i < $scope.macros.length; i++){
                        if(vpAdminApp.defaultStartupMacro == $scope.macros[i]){
                            matchedMacro = true;
                            break;
                        }
                    }
                    if(!matchedMacro)
                        vpAdminApp.defaultStartupMacro = "None";
                    $scope.selectedStartupMacro = vpAdminApp.defaultStartupMacro;

                //}else
                //     $scope.selectedStartupMacro = vpAdminApp.defaultStartupMacro;
                vpAdminApp.Grid = $scope.xmlDOM;
                
                //The reason of using a timeout here is because, in this moment, we don't have the Tree's DOM element yet.
                setTimeout(function(){

                    //Special case: In case that we don't have any display in the application.
                    if($scope.tree[0].children.length == 0){
                        $('input[type=radio]').remove();
                        $('.check').prop("checked", true);
                        $('.expander').removeClass('ng-hide');
                        $('.css-treeview div').css('display','none');
                    }
                    //End of special case.

                    checkParentCheckbox($scope.tree[0]);
                    if (totalSelectedItems > 0) {
                        $scope.setGrandParent(totalSelectedItems);
                    }
                    checkMobileEnableParentCheckbox($scope.tree[0]);
                    if (totalMobileEnableItems > 0) {
                        $scope.setMobileEnableGrandParent(totalMobileEnableItems);
                    }
                    if ($scope.tree[0]) {
                        var initDisplay = FindInitialDisplay(DisplaysTree.tree[0]);
                        if (initDisplay == undefined) {
                            var fullname = args.getStartupDisplay();
                            $scope.onRadioClicked(fullname ? fullname : GetFirstGraphicDisplay($scope.tree[0]).FullName);
                        } else {
                            $scope.onRadioClicked(initDisplay.FullName);
                        }
                    } else {
                        document.getElementById($scope.tree[0].FullName).checked = true;
                        vpAdminApp.Grid = undefined;
                        ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified = true;
                    }
                    $scope.$apply();
                }, 10);

                $('body').css("cursor", "default");
            }, clientIdentifier, appToOpen, reloadExistingApp);
            
        } else {
            $scope.tree = DisplaysTree.tree;
            $scope.macros = DisplaysTree.macroList;
            $scope.selectedStartupMacro = vpAdminApp.defaultStartupMacro;
            $scope.forceRepublish = DisplaysTree.forceRepublish;
            $scope.xmlDOM = DisplaysTree.DOM;
            //ppei: fix anomaly CVBFTVIEW-2321
            totalSelectedItems = $($scope.xmlDOM.find("GraphicsDisplay").find("Selected:Contains(true)")).length
            totalMobileEnableItems = $($scope.xmlDOM.find("GraphicsDisplay").find("MobileEnable:Contains(true)")).length;
            setTimeout(function(){
                checkParentCheckbox($scope.tree[0]);
                if (totalSelectedItems > 0) {
                    $scope.setGrandParent(totalSelectedItems);
                }
				
                checkMobileEnableParentCheckbox($scope.tree[0]);
                if (totalMobileEnableItems > 0) {
                    $scope.setMobileEnableGrandParent(totalMobileEnableItems);
                }
            },10);
            
            if (vpAdminApp.success){
                document.getElementById('firstApp').style.display = 'block';
            }
        }
        if ($scope.tree.length === 0 && !vpAdminApp.success) 
            document.getElementById('firstApp').style.display = 'none';
        /*else {
            vpAdminApp.Grid = undefined;
            ViewPoint.Client.VPAdmin.SelectApp.GetSelectAppClass().m_ApplicationListModified = true;
        }*/

        $('#aLpAppSelectDisplay').css("cursor", "default");        
    }
    
    var totalSelectedItems = 0;
    var totalMobileEnableItems = 0;
  //This method checks if the Root Node is indeterminate check value or a normal check value
    $scope.setGrandParent = function (totalSelectedItems) {
        var totalDisplays = getDisplaysCount($scope.tree[0],0);
        $scope.setCheckVal($scope.tree[0].FullName, totalDisplays, totalSelectedItems);
    }

    //This method checks if the Specific Parent Node is indeterminate check value or a normal check value
    $scope.setParent = function (parentName, selectedGraphics) {
        var totalGraphics = getGraphicCount($scope.tree[0],parentName);
        return $scope.setCheckVal(parentName, totalGraphics, selectedGraphics);
    }

    //This method determine wheather a checkbox should be an indeterminate or a normal check
    $scope.setCheckVal = function (name, total, selected) {
        if (name) {
            var elem = document.getElementById(name);
            if (total == selected) {
                elem.checked = true;
                var node = FindNode($scope.tree[0],name);
                if(undefined!=node){
                    node.Selected = true;					 
                }
                elem.indeterminate = false;
                node.isIndeterminate = false;
                return true;
            } else {
                elem.checked = false;
                var node = FindNode($scope.tree[0],name);
                if(undefined!=node){
                    node.Selected = false;					 
		}
                elem.indeterminate = selected > 0;     
                node.isIndeterminate = selected > 0; 
                return false;          
            }
        }
    }

    $scope.forceRepublishClick = function () {
    	DisplaysTree.forceRepublish = !DisplaysTree.forceRepublish;
    	$scope.forceRepublish = DisplaysTree.forceRepublish;
    }
    $scope.onParentNodeClicked = function (selected, parentName) {
         var node = FindNode($scope.tree[0],parentName);
         ProcessParentClick(node,"Selected",!selected);   
        
         var selecteddisplays = getCount(node, "Selected", true);
         checkParentToTree(node, true, selecteddisplays, 0);
         
         var totalSelectedItems = getCount($scope.tree[0], "Selected", true);
         validateIfuncheckGrandParentCheckbox(0,totalSelectedItems);
         //martin change to avoid previously try catch has error effect with new added folder selected
        //ppei:fix anomaly CVBFTVFTVP-2139, add '' to escape special characters [] ()
        if ($($scope.xmlDOM.find("FullName:contains(" + "'" + parentName + "'" + ")"))[0] != undefined && node.isFolder != true) {
            $($($scope.xmlDOM.find("FullName:contains(" + "'" + parentName + "'" + ")"))[0].parentNode.childNodes).find("Selected").each(function (index, ele) {
                ele.textContent = !selected;
            });
            var length = $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")).length;
            if (length == 0)
                checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0], "");
        }else{
            //martin add to let folder can be selected
            if ($($scope.xmlDOM.find("Folder:contains(" + "'" + node.Name + "'" + ")"))[0] != undefined){
                var folderNodes = $($scope.xmlDOM.find("Folder:contains(" + "'" + node.Name + "'" + ")"));
                var _nodeAreaName;
                var findNodeAreaName = function(_node){
                    if(_node.children.length>0){
                        var children = $(_node.children);
                        children.each(function(index,child){
                            if(child.isFolder != undefined && child.isFolder == true){
                                findNodeAreaName(child);
                                return;
                            }else{
                                if(child.AreaName){
                                    _nodeAreaName = child.AreaName;
                                }
                            }
                        });
                    }
                }

                folderNodes.each(function(index, folder){
                    var folderNode = folder;
                    var siblingsNode = $(folderNode.parentNode.childNodes);
                    var xmlAreaName, nodeAreaName;
                    //node view
                    siblingsNode.each(function(i,v){
                        if(v.nodeName == 'AreaName'){
                            xmlAreaName = v.textContent;
                            return;
                        }
                    });
                    //tree view
                    findNodeAreaName(node);
                    nodeAreaName = _nodeAreaName;
                    if(xmlAreaName === nodeAreaName){
                        siblingsNode.each(function(i,v){
                            if(v.nodeName == 'Selected'){
                                v.textContent = !selected;
                            }
                        });
                    }
                });
            }

            var length = $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")).length;
            if (length == 0)
                checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0], "");
        }
    }

    $scope.onRootNodeClicked = function () {
        var selected = !document.getElementById($scope.tree[0].FullName).checked;
        if(!$scope.tree[0])
            return;
        $('body').css("cursor", "wait");
        clickAllCheckboxes(!selected, $scope.tree[0]);   

        if (!selected == false){
            $scope.clearRadioValue($scope.tree[0]);	
            clickAllMobileEnableCheckboxes(!selected, $scope.tree[0]);   
            $scope.onSelectedAllMobileEnableChanged(!selected);				
        }

        else {
            //$scope.clearRadioValue($scope.tree[0]);
            var length = $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")).length;
            if (length == 0)
                checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0],"");
            
        }     
          
        
        //Disable/Enable all radio buttons
        $('table[data-tree]').find('input:radio').prop('disabled', !selected);

        $scope.onSelectedAllChanged(!selected);
        if (!selected == true) {
            totalSelectedItems = getDisplaysCount($scope.tree[0],0);
        } else {
            totalSelectedItems = 0;
        }
        $('body').css("cursor", "default");
    }

    //This method performs to check or uncheck all the checkboxes in the Tree
    var clickAllCheckboxes = function (selected, tree) {
        //This is a leaf

        var elem = document.getElementById(tree.FullName);
        elem.indeterminate = false;
        if(tree.children.length == 0){
            tree.Selected = selected
        }
        else{
            for(var i = 0; i < tree.children.length; i++){
                tree.Selected = selected;
                clickAllCheckboxes(selected,tree.children[i]);
            }
        }
        return undefined;
    }

  
    $scope.xmlDOM = null;

    //StartupMacro combobox
    $scope.macros = [
      ];

    $scope.forceRepublish = false;

    //TreeGrid Data
    $scope.tree = [
    ];

    $scope.selectedStartupMacro = "None";

    $scope.changeMacro = function(){
        vpAdminApp.defaultStartupMacro = $scope.selectedStartupMacro;
    }

    //This method is called when the user clicked the label of the tree item
    $scope.onLabelClick = function (name, isSelected) {
       
        $scope.onSelectedChanged(name, isSelected);
        var node = FindNode($scope.tree[0], name);
        node.Selected = !isSelected;
    }

    $scope.dblclick = function(node){//IE has double click on checkboxs, that causes problems with the visual check state
        node.Selected = !node.Selected;
        var childrenLength = node.children.length || 0;
        if(childrenLength > 0){
            //Check if Current Node is Root Node
            var element = document.getElementById($scope.tree[0].FullName); 
            element.checked = !element.checked;
            if(node.FullName == $scope.tree[0].FullName)
                $scope.onRootNodeClicked();
            else
                $scope.onParentNodeClicked(node.Selected,node.FullName);
            
        }
    }

    //This method processes the action click of an checkbox
    $scope.onSelectedChanged = function (node, isSelected,length) {
        var name = node.FullName;
        if(length > 0){
            //Check if Current Node is Root Node
            if(name == $scope.tree[0].FullName){
                $scope.onRootNodeClicked();
            }else{
                $scope.onParentNodeClicked(isSelected,name);
            }
        }else{
            var findResult = $scope.xmlDOM.find("FullName:contains(" + "'" + name + "'" + ")");
            if (findResult.length == 0) return;
    	    var i = 0;
    	    if (findResult.length > 1) {
    		    for (i = 0; i < findResult.length; i++) {
    			    if ($(findResult[i].parentNode).find("FullName")[0].textContent == name) break;
    		    }
    	    }
    	    $(findResult[i].parentNode).find("Selected")[0].textContent = !isSelected;
    	    $scope.checkRadioButtonListState(name, !isSelected);

            var parentNode = null;
            for(var i =0; i < $scope.tree[0].children.length; i++){
                if($scope.tree[0].children[i].FullName == name){
                    parentNode = $scope.tree[0];
                    break;
                 }
            }
            if(parentNode == null)
                parentNode = FindParentNode($scope.tree[0],name);
            if(!isSelected){
                 var val =  getCount(parentNode, "Selected", true) + 1;
                 var totalSelectedItems = getCount($scope.tree[0], "Selected", true)+1;
                 $scope.setGrandParent(totalSelectedItems);
                 checkParentToTree(parentNode, true, val, 1);
            }else{
                var val = getCount(parentNode, "Selected", true) - 1 ;
                checkParentToTree(parentNode, val > 0, val, -1);
                var totalSelectedItems = getCount($scope.tree[0], "Selected", true)-1;
                validateIfuncheckGrandParentCheckbox(-1,totalSelectedItems);
            }
            
        }
        if(isSelected){
            if(name != $scope.tree[0].FullName){
                node.MobileEnable = false;
                $scope.onMobileEnableChanged(node, true, length, false);
            }			
        }
	
    }


    //This method checks if the Root Node is indeterminate check value or a normal check value
    $scope.setMobileEnableGrandParent = function (totalMobileEnableItems) {
        var totalDisplays = getDisplaysCount($scope.tree[0], 0);
        $scope.setMobileEnableCheckVal($scope.tree[0].FullName, totalDisplays, totalMobileEnableItems);
    }

	var FindMobileEnableNode = function(tree, nodeName){
        if('M_' + tree.FullName == nodeName)
            return tree;
        else{
            for(var i = 0; i < tree.children.length; i++){
                var res = FindMobileEnableNode(tree.children[i], nodeName);
                if(res){
                    return res;
                }
            }
        }
        return undefined;
    }
    //This method determine wheather a checkbox should be an indeterminate or a normal check
    $scope.setMobileEnableCheckVal = function (name, total, mobileEnable) {
        if (name) {
            var elem = document.getElementById('M_' + name);
            if (total == mobileEnable) {
                elem.checked = true;
                var node = FindMobileEnableNode($scope.tree[0],'M_' + name);
                if(undefined!=node){
                    node.MobileEnable = true;					 
                }
                elem.indeterminate = false;
                node.isMobileIndeterminate = false;
                return true;
            } else {
                elem.checked = false;
                var node = FindMobileEnableNode($scope.tree[0],'M_' + name);
                if(undefined!=node){
                    node.MobileEnable = false;					 
                }				
                elem.indeterminate = mobileEnable > 0;
                node.isMobileIndeterminate = mobileEnable > 0;
                return false;
            }
        }
    }
    var FindMobileEnableParentNode = function (tree, nodeName) {
        if (tree.FullName == nodeName && tree.children.length == 0)
            return tree.parent;
        else {
            for (var i = 0; i < tree.children.length; i++) {
                var res = FindMobileEnableParentNode(tree.children[i], nodeName);
                if (res) {
                    return res;
                }
            }
        }

    }
	
	//This processes all the actions that should be performed when user clicks a parent node
    var ProcessAddListParentClick = function (tree,attribute,value) {
            tree[attribute] = value;
            var elem = document.getElementById('M_'+ tree.FullName);
            elem.indeterminate = false;
            for (var x = 0; x < tree.children.length; x++) {
                ProcessAddListParentClick(tree.children[x], attribute,value);
            }
    }
	//This method checks if the Specific Parent Node is indeterminate check value or a normal check value
    $scope.setMobileEnableParent = function (parentName, selectedGraphics) {
        var totalGraphics = getGraphicCount($scope.tree[0], parentName);
        return $scope.setMobileEnableCheckVal(parentName, totalGraphics, selectedGraphics);
    }

	//This method finds the the specific parentNode, then calls to setParent method in order to set the node's adecuate checkbox value.
    var checkMobileEnableParentToTree = function (node, checked, graphCount, addOrSubstract) {        
        
        node.MobileEnable = $scope.setMobileEnableParent(node.FullName, graphCount);
        if(node.parent){
            var count = getCount(node.parent, "MobileEnable", true);
            count += addOrSubstract;
            checkMobileEnableParentToTree(node.parent, checked, count, addOrSubstract);
        }
    }
	var validateIfuncheckMobileEnableGrandParentCheckbox = function (numberToSubstract, totalMobileEnableSelected) {
        var count = getCount($scope.tree[0], "MobileEnable", true) + numberToSubstract;
        $scope.setMobileEnableGrandParent(totalMobileEnableSelected);
    }
	$scope.onMobileEnableParentNodeClicked = function (mobileEnable, parentName) {
         var node = FindNode($scope.tree[0],parentName);
         ProcessAddListParentClick(node,"MobileEnable",!mobileEnable);   
        
         var selecteddisplays = getCount(node, "MobileEnable", true);
         checkMobileEnableParentToTree(node, true, selecteddisplays, 0);
         
         var totalMobileEnableItems = getCount($scope.tree[0], "MobileEnable", true);
         validateIfuncheckMobileEnableGrandParentCheckbox(0,totalMobileEnableItems);
         //martin add to let folder can be selected at mobile enable
         try {
            //ppei:fix anomaly CVBFTVFTVP-2139, add '' to escape special characters [] ()
            if ($($scope.xmlDOM.find("FullName:contains(" + "'" + parentName + "'" + ")"))[0] != undefined && node.isFolder != true) {
                $($($scope.xmlDOM.find("FullName:contains(" + "'" + parentName + "'" + ")"))[0].parentNode.childNodes).find("MobileEnable").each(function (index, ele) {
                    ele.textContent = !mobileEnable;
                });
                var length = $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")).length;
                if (length == 0)
                    checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0], "");
            } else {
                if ($($scope.xmlDOM.find("Folder:contains(" + node.Name + ")"))[0] != undefined) {
                    var folderNodes = $($scope.xmlDOM.find("Folder:contains(" + node.Name + ")"));
                    var _nodeAreaName;
                    var findNodeAreaName = function (_node) {
                        if (_node.children.length > 0) {
                            var children = $(_node.children);
                            children.each(function (index, child) {
                                if (child.isFolder != undefined && child.isFolder == true) {
                                    findNodeAreaName(child);
                                    return;
                                } else {
                                    if (child.AreaName) {
                                        _nodeAreaName = child.AreaName;
                                    }
                                }
                            });
                        }
                    }

                    folderNodes.each(function (index, folder) {
                        var folderNode = folder;
                        var siblingsNode = $(folderNode.parentNode.childNodes);
                        var xmlAreaName, nodeAreaName;
                        //node view
                        siblingsNode.each(function (i, v) {
                            if (v.nodeName == 'AreaName') {
                                xmlAreaName = v.textContent;
                                return;
                            }
                        });
                        //tree view
                        findNodeAreaName(node);
                        nodeAreaName = _nodeAreaName;
                        if (xmlAreaName === nodeAreaName) {
                            siblingsNode.each(function (i, v) {
                                if (v.nodeName == 'MobileEnable') {
                                    v.textContent = !mobileEnable;
                                }
                            });
                        }
                    });
                }
            }

        } catch (e) { }
    }

	//This method performs to check or uncheck all the checkboxes in the Tree
    var clickAllMobileEnableCheckboxes = function (mobileEnable, tree) {
        //This is a leaf

        var elem = document.getElementById('M_'+tree.FullName);
        elem.indeterminate = false;
        if (tree.children.length == 0 && tree.Selected === true) {
            tree.MobileEnable = mobileEnable;
			console.log(mobileEnable);
        }
		else if(tree.children.length == 0 && tree.Selected === false){
            tree.MobileEnable = false;
			console.log(mobileEnable);			
		}
        else {
            for (var i = 0; i < tree.children.length; i++) {
				tree.MobileEnable = mobileEnable;
                clickAllMobileEnableCheckboxes(mobileEnable, tree.children[i]);
            }
        }
        return undefined;
    }

	$scope.onSelectedAllMobileEnableChanged = function (selectValue) {
        $($scope.xmlDOM.find("MobileEnable")).each(function (index, value) {
            value.textContent = selectValue;
        })
    }
	
	$scope.onMobileEnableRootNodeClicked = function () {
        var mobileEnable = !document.getElementById('M_'+$scope.tree[0].FullName).checked;
        if(!$scope.tree[0])
            return;
        $('body').css("cursor", "wait");
        clickAllMobileEnableCheckboxes(!mobileEnable, $scope.tree[0]);   

        $scope.onSelectedAllMobileEnableChanged(!mobileEnable);
        if (!mobileEnable == true) {
            totalMobileEnableItems = getDisplaysCount($scope.tree[0],0);
        } else {
            totalMobileEnableItems = 0;
        }
        $('body').css("cursor", "default");
    }
	
	$scope.dblclickmobileenable = function(node){//IE has double click on checkboxs, that causes problems with the visual check state
        node.MobileEnable = !node.MobileEnable;
        var childrenLength = node.children.length || 0;
        if(childrenLength > 0){
            //Check if Current Node is Root Node
            var element = document.getElementById('M_' +$scope.tree[0].FullName); 
            element.checked = !element.checked;
            if(node.FullName == $scope.tree[0].FullName)
                $scope.onMobileEnableRootNodeClicked();
            else
                $scope.onMobileEnableParentNodeClicked(node.MobileEnable,node.FullName);
            
        }
    }
	
    $scope.onMobileEnableChanged = function (node, isMobileEnable, length, mobileClick) {
        var name = node.FullName;
        if (length > 0) {
            //Check if Current Node is Root Node
            if (name == $scope.tree[0].FullName) {
                $scope.onMobileEnableRootNodeClicked();
            } else {
                $scope.onMobileEnableParentNodeClicked(isMobileEnable, name);
            }
        } else {
            var findResult = $scope.xmlDOM.find("FullName:contains(" + "'" + node.FullName + "'" + ")");
            if (findResult.length == 0) return;
            var i = 0;
            if (findResult.length > 1) {
                for (i = 0; i < findResult.length; i++) {
                    if ($(findResult[i].parentNode).find("FullName")[0].textContent == node.FullName) break;
                }
            }
            $(findResult[i].parentNode).find("MobileEnable")[0].textContent = !isMobileEnable;

            var parentNode = null;
            for (var i = 0; i < $scope.tree[0].children.length; i++) {
                if ($scope.tree[0].children[i].FullName == name) {
                    parentNode = $scope.tree[0];
                    break;
                }
            }
            if (parentNode == null)
                parentNode = FindMobileEnableParentNode($scope.tree[0], name);
            if (!isMobileEnable) {
                var val = getCount(parentNode, "MobileEnable", true) + 1;
                var totalMobileEnableItems = getCount($scope.tree[0], "MobileEnable", true) + 1;
                $scope.setMobileEnableGrandParent(totalMobileEnableItems);
                checkMobileEnableParentToTree(parentNode, true, val, 1);
            } else {
                //martin add a argument to determine it is clicked by mobile enable or by web enable,
                //then assign different number to sub.
                var subNum = mobileClick == true ? 1 : 0;
                var val = getCount(parentNode, "MobileEnable", true) - subNum;
                checkMobileEnableParentToTree(parentNode, val > 0, val, -subNum);
                var totalMobileEnableItems = getCount($scope.tree[0], "MobileEnable", true) - subNum;
                validateIfuncheckMobileEnableGrandParentCheckbox(-1, totalMobileEnableItems);
            }

        }
    }
    
    var addGraphicSelectionCount = function (parentName, num) {
        for (var i = 0; i < $scope.tree.length; i++) {
            if ($scope.tree[i].name == parentName) {
                $scope.tree[i].graphicsSelectedLength += num;
                break;
            }
        }
    }
   
    //This methods returns the number of displays that is under the some specific node
    var getGraphicCount = function (tree,parentName) {
        var node = FindNode(tree, parentName);
        var counter = 0;
        if(node.children.length == 0)
            return 0;
        else {
            for (var x = 0; x < node.children.length; x++) {                
                 counter += getDisplaysCount(node.children[x], counter);
            }
        }
        return counter;
    }

    //This method finds the the specific parentNode, then calls to setParent method in order to set the node's adecuate checkbox value.
    var checkParentToTree = function (node, checked, graphCount, addOrSubstract) {        
        
        node.Selected = $scope.setParent(node.FullName, graphCount);
        if(node.parent){
            var count = getCount(node.parent, "Selected", true);
            count += addOrSubstract;
            checkParentToTree(node.parent, checked, count, addOrSubstract);
        }
    }
    var validateIfuncheckGrandParentCheckbox = function (numberToSubstract, totalItemSelected) {
        var count = getCount($scope.tree[0], "Selected", true) + numberToSubstract;
        $scope.setGrandParent(totalItemSelected);
        if (count == 0) {
            $scope.clearRadioValue($scope.tree[0])
        }
    }
    $scope.onSelectedAllChanged = function (selectValue) {
        $($scope.xmlDOM.find("Selected")).each(function (index, value) {
            value.textContent = selectValue;
        })
    }

    $scope.checkRadioButtonListState = function (name, selected) {
        //var selector = "input:radio[value=\"" + name + "\"]";
        //$(selector)[0].disabled = !selected;
        var length = $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")).length;
            if (length == 0 && selected) {
                $scope.onRadioClicked(name);
            } else if (length == 1 && !selected && $($scope.xmlDOM.find("IsInitialDisplay:Contains(true)")[0].parentNode).find("FullName")[0].textContent == name) {
                $scope.clearRadioValue($scope.tree[0]);
                //setTimeout($scope.checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay, 1);
                checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0],name);
            }
    }

    var checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay = function (tree,nodeName) {
        nodeFinded = {level: 0, node: undefined};
        var node = findRadioButton(tree, nodeName, 0).node;

        if(node == undefined)
            return;
        node.IsInitialDisplay = node.FullName;
        var selector = "FullName:contains(" + "'" + node.FullName + "'" + ")";
        var jquery = $scope.xmlDOM.find(selector);
        if(jquery.length > 1){
            for(var i=0; i< jquery.length; i++){
                 if(jquery[i].textContent == node.FullName && (jquery[i].nodeName == "GraphicsDisplay" || $(jquery[i]).parent()[0].nodeName == "GraphicsDisplay")){
                    $(jquery[i].parentNode).find("IsInitialDisplay")[0].textContent = true;
                }
            }
         }else{
             $(jquery[0].parentNode).find("IsInitialDisplay")[0].textContent = true;   
        }
        
    }

    var nodeFinded;
    var findRadioButton = function(tree, nodeName, level){
        if(tree.children.length == 0 && tree.FullName != nodeName && tree.Selected)
            return {level: level, node: tree};
        else{
            for(var i = 0; i < tree.children.length; i++){
                var actualNode = findRadioButton(tree.children[i], nodeName, level+1);
                if(nodeFinded.node == undefined && actualNode.node != undefined)
                    nodeFinded = actualNode;
                else if(actualNode.level < nodeFinded.level)
                    nodeFinded = actualNode;
            }
            return nodeFinded;
        }

    }

    $scope.onRadioClicked = function (name) {
            $scope.clearRadioValue($scope.tree[0]);
            if(!$scope.tree[0])
                return;
            var selector = "FullName:contains(" + "'" + name + "'" + ")";
            var TheFirstDisplay = GetFirstGraphicDisplay($scope.tree[0]);
            var findResult = $scope.xmlDOM.find(selector).filter(function(){ return $(this).text() === name;});
            if (findResult.length == 0) { // in case not found select first
            	
                checkIfThereAreAnotherCheckboxAvailableToPlaceInitialDisplay($scope.tree[0],"");
                return;
            }
            if (findResult.length > 0) {
            	var i = 0;            	
            	if (findResult.length > 1) {
            		if (name.indexOf('/') >= 0) name = name.substring(name.lastIndexOf('/') + 1);
            		for (i = 0; i < findResult.length; i++) {
                        var obj = $(findResult[i].parentNode).find("Name");
            			if (obj[0].textContent == name && obj.parent()[0].nodeName == "GraphicsDisplay" ) break;
            		}
            	}
            	$(findResult[i].parentNode).find("IsInitialDisplay")[0].textContent = true;
            	name = $(findResult[i].parentNode).find("FullName")[0].textContent;
            } else {
            	$($scope.xmlDOM.find("GraphicsDisplay")[0]).find("IsInitialDisplay")[0].textContent = true;
            	TheFirstDisplay.IsInitialDisplay = $($scope.xmlDOM.find("GraphicsDisplay")[0]).find("FullName")[0].textContent;
            	return;
            }
    	
        SetIsInitialDisplayValue($scope.tree[0],name);
    }
    
    $scope.onRadioClickedByUser = function (node) {
        $scope.clearRadioValue($scope.tree[0]);
        $scope.onRadioClicked(node.FullName);
    }
    $scope.clearRadioValue = function (tree) {
       
        //This is a leaf
        if(tree.children.length == 0){
            if( (tree.IsInitialDisplay !== false || tree.IsInitialDisplay == "0")  && (tree.IsInitialDisplay !== true || tree.IsInitialDisplay == "1") && tree.IsInitialDisplay != ""){
                tree.IsInitialDisplay = "";
                var query = $scope.xmlDOM.find("IsInitialDisplay:contains('true')");
                if (query.length > 0)
                    query[0].textContent = false;
                return true;
            }
        }
        else{
            for(var i = 0; i < tree.children.length; i++){
                var res = $scope.clearRadioValue(tree.children[i]);
                if(res)
                    return;
            }
        }
        return undefined;
    }

    //Count the amount that matches with the attribute and its value
    var getCount = function (tree, attribute, value) {
        var counter = 0;
        if(tree.children.length == 0 && tree[attribute] == value && tree.IsGraphicsDisplay)
            return 1;       
        else {
            for (var x = 0; x < tree.children.length; x++) {
                counter += getCount(tree.children[x], attribute,value);
            }
        }
        return counter;
    }

    //Set to 'attribute' its 'value' for all the nodes under the tree
    var SetValue = function (tree,attribute,value) {
        var counter = 0;
        if(tree.children.length == 0)
            tree[attribute] = value;        
        else {
            tree[attribute] = value;
            for (var x = 0; x < tree.children.length; x++) {
                SetValue(tree.children[x], attribute,value);
            }
        }
    }

    //This processes all the actions that should be performed when user clicks a parent node
    var ProcessParentClick = function (tree,attribute,value) {
        var counter = 0;
        if(tree.children.length == 0){
            tree[attribute] = value;  
            if (tree.IsInitialDisplay != "false" && tree.IsInitialDisplay != "true" && tree.IsInitialDisplay != "") {
                tree.IsInitialDisplay = "";
                $scope.xmlDOM.find("IsInitialDisplay:contains('true')")[0].textContent = false;
            }
        }else {
            tree[attribute] = value;
            var elem = document.getElementById(tree.FullName);
            elem.indeterminate = false;
            for (var x = 0; x < tree.children.length; x++) {
                ProcessParentClick(tree.children[x], attribute,value);
            }
        }
    }
    //This method counts the ammount of graphic displays (leafs) under an specific node
    var getDisplaysCount = function (tree, counter) {
        var counter = 0;
        if(tree.children.length == 0)
            return 1;
        else {
            for (var x = 0; x < tree.children.length; x++) {
                counter += getDisplaysCount(tree.children[x], counter);
            }
        }
        return counter;
    }

    $scope.onNext = function () {
        var count = getCount($scope.tree[0], "Selected", true);
        if (count == 0) {
            if (getDisplaysCount($scope.tree[0],0) > 0 || vpAdminApp.success) ViewPoint.Client.VPAdmin.VPAdminUtil.ShowMessage(ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("noStartUpDisplay"), ViewPoint.Client.Toolkit.Controls.MessageType.None, ViewPoint.Client.Toolkit.Controls.DialogBoxButtons.Ok);
            $location.path('/selectdisplays');
        } else if (count > 0) {
            DisplaysTree.PublishTable = BuildPublishTable($scope.tree[0], []);
            DisplaysTree.treeXML = $scope.serialize($scope.selectedStartupMacro, $scope.xmlDOM);
            /*for IE and Mozilla, problem with the xmlns attribute, is not required*/
            if(DisplaysTree.treeXML.indexOf('xmlns=""') !== -1) DisplaysTree.treeXML = DisplaysTree.treeXML.replace('xmlns=""',''); 
            ViewPoint.Client.VPAdmin.Application.GetViewPointAdminApp().ResetPublish();
            //vpAdminApp.defaultStartupMacro = undefined;
            $location.path('/publishapp');
        }
    }
    $scope.serialize = function (selectedStartupMacro, ftViewApplication) {
        var serializer = new XMLSerializer();
        ftViewApplication.find('StartupMacro').remove();
        if (selectedStartupMacro == "None")
            return serializer.serializeToString(ftViewApplication[0]);
        var xmlnode = '<StartupMacro>' + selectedStartupMacro + '</StartupMacro>';
        var parser = new DOMParser();
        var startup = parser.parseFromString(xmlnode,'text/xml');
        var temp = ftViewApplication.append(startup.childNodes[0]);        
        return serializer.serializeToString(temp[0]);
    }

    //This method finds the Graphic Display that is also the Initial Display
    var FindInitialDisplay = function (tree) {
        
        //This is a leaf
        if(tree.children.length == 0){
            if(tree.IsInitialDisplay == true)
                return tree;
        }
        else{
            for(var i = 0; i < tree.children.length; i++){
                return FindInitialDisplay(tree.children[i]);
            }
        }
        return undefined;
    }

    //This method finds the first Graphic Display which is come from the XML
    var GetFirstGraphicDisplay = function(tree){
        if(tree.children.length == 0){
            return tree;
        }
        else{
            for(var i = 0; i < tree.children.length; i++){
                return GetFirstGraphicDisplay(tree.children[i]);
            }
        }
        return undefined;
    }

    //This method sets new value for the IsInitialDisplay, binding with its corresponding RadioButton
    var SetIsInitialDisplayValue = function (tree,name) {
        if(tree.children.length == 0){
            if(tree.FullName == name){
                tree.IsInitialDisplay = name;
                return true;
            }
        }
        else{
            for(var i = 0; i < tree.children.length; i++){
                var res = SetIsInitialDisplayValue(tree.children[i],name);
                if(res)
                    return res;
            }
        }
        return undefined;
    }

    var FindNode = function(tree, nodeName){
        if(tree.FullName == nodeName)
            return tree;
        else{
            for(var i = 0; i < tree.children.length; i++){
                var res = FindNode(tree.children[i], nodeName);
                if(res){
                    return res;
                }
            }
        }
        return undefined;
    }

    var FindParentNode = function(tree, nodeName){
        if(tree.FullName == nodeName && tree.children.length == 0)
            return tree.parent;
        else{
            for(var i = 0; i < tree.children.length; i++){
                var res = FindParentNode(tree.children[i], nodeName);
                if(res){
                    return res;
                }
            }
        }
       
    }

    var BuildPublishTable = function (tree, newTable) {
        var counter = 0;
        if (tree.children.length == 0) {
            if (tree.Selected) {
                var publishTxt = ViewPoint.Client.VPAdmin.VPAdminUtil.GetString("NewPublish");
                tree.PublishStatus = publishTxt;
                newTable.push(tree);
            }
        }
        else {
            for (var x = 0; x < tree.children.length; x++) {
                BuildPublishTable(tree.children[x], newTable);
            }
            return newTable;
        }
    }

    var checkParentCheckbox = function (tree) {
        if (tree.children.length > 0) {
            var selectedCount = 0;
            for (var i = 0; i < tree.children.length; i++) {
                
                    selectedCount += checkParentCheckbox(tree.children[i]);
                
            }
            $scope.setParent(tree.FullName, selectedCount)
            tree.Selected = document.getElementById(tree.FullName).checked || false;
            return selectedCount;
        }
        else {
            return (tree.Selected) ? 1 : 0;
        }
    }
	var checkMobileEnableParentCheckbox = function (tree) {
        if (tree.children.length > 0) {
            var selectedCount = 0;
            for (var i = 0; i < tree.children.length; i++) {
                
                    selectedCount += checkMobileEnableParentCheckbox(tree.children[i]);
                
            }
            $scope.setMobileEnableParent(tree.FullName, selectedCount)
            tree.MobileEnable = document.getElementById('M_'+tree.FullName).checked || false;
            return selectedCount;
        }
        else {
            return (tree.MobileEnable) ? 1 : 0;
        }
    }
});


